



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>【bzoj 1901】Zju2112 Dynamic Rankings</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">【bzoj 1901】Zju2112 Dynamic Rankings</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-18 22:19:11 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>Description</h2>
<div>给定一个含有n个数的序列a[1],a[2],a[3]&hellip;&hellip;a[n]，程序必须回答这样的询问：对于给定的i,j,k，在a[i],a[i+1],a[i+2]&hellip;&hellip;a[j]中第k小的数是多少(1&le;k&le;j-i+1)，并且，你可以改变一些a[i]的值，改变后，程序还能针对改变后的a继续回答上面的问题。</div>
<h2>Input</h2>
<div>
<div>第一行有两个正整数n(1&le;n&le;10000)，m(1&le;m&le;10000)。</div>
<div>分别表示序列的长度和指令的个数。</div>
<div>第二行有n个数，表示a[1],a[2]&hellip;&hellip;a[n]，这些数都小于10^9。</div>
<div>接下来的m行描述每条指令</div>
<div>每行的格式是下面两种格式中的一种。&nbsp;</div>
<div>Q i j k 或者 C i t&nbsp;</div>
<div>Q i j k （i,j,k是数字，1&le;i&le;j&le;n, 1&le;k&le;j-i+1）</div>
<div>表示询问指令，询问a[i]，a[i+1]&hellip;&hellip;a[j]中第k小的数。</div>
<div>C i t (1&le;i&le;n，0&le;t&le;10^9)表示把a[i]改变成为t</div>
<div>m,n&le;10000</div>
</div>
<h2>Output</h2>
<p>对于每一次询问，你都需要输出他的答案，每一个输出占单独的一行。</p>
<h2>Sample Input</h2>
<p>5 3<br />
3 2 1 4 7<br />
Q 1 4 3<br />
C 2 6<br />
Q 2 5 3</p>
<h2>Sample Output</h2>
<p>3<br />
6</p>
<p>带修改的整体二分&hellip;&hellip;整体二分不会改变操作顺序，把修改也加进操作就可以了&radic;</p>
<div>
<div>
<pre class="prettyprint linenums"> #include&lt;cstdio&gt;<br />
 #include&lt;algorithm&gt;<br />
 #include&lt;cstring&gt;<br />
 #define LL long long<br />
 using namespace std;<br />
 const int N=5e4+;<br />
 const int inf=1e9;<br />
 int n,m,cnt,qid,id,temp,x[N],ans[N],tr[N];<br />
 bool f[N];<br />
 char ch[];<br />
 struct node{int op,l,r,k,num;}a[N],tmp[N];<br />
 int lowbit(int x){return x&amp;(-x);}<br />
 void insert(int x,int c){while(x&lt;=n)tr[x]+=c,x+=lowbit(x);}<br />
 int query(int x){int ans=;while(x)ans+=tr[x],x-=lowbit(x);return ans;}<br />
 int read()<br />
 {<br />
     int x=,f=;char c=getchar();<br />
     while(c&lt;''||c&gt;''){if(c=='-')f=-;c=getchar();}<br />
     while(c&gt;=''&amp;&amp;c&lt;=''){x=x*+c-'';c=getchar();}<br />
     return x*f;<br />
 }<br />
 void work(int ql,int qr,int L,int R)<br />
 {<br />
     if(ql&gt;qr||L&gt;R)return;<br />
     if(L==R){for(int i=ql;i&lt;=qr;i++)if(a[i].op)ans[a[i].num]=L;return;}<br />
     int mid=(L+R)&gt;&gt;,h1=ql,h2=ql;<br />
     for(int i=ql;i&lt;=qr;i++)<br />
         if(a[i].op)<br />
         {<br />
             temp=query(a[i].r)-query(a[i].l-);<br />
             if(temp&gt;=a[i].k)f[i]=true,h2++;<br />
             else f[i]=false,a[i].k-=temp;<br />
         }<br />
         else<br />
         {<br />
             if(a[i].num&lt;=mid)f[i]=true,h2++,insert(a[i].l,a[i].k);<br />
             else f[i]=false;<br />
         }<br />
     for(int i=ql;i&lt;=qr;i++)if((!a[i].op)&amp;&amp;f[i])insert(a[i].l,-a[i].k);<br />
     for(int i=ql;i&lt;=qr;i++)<br />
         if(f[i])tmp[h1++]=a[i];<br />
         else tmp[h2++]=a[i];<br />
     for(int i=ql;i&lt;=qr;i++)a[i]=tmp[i];<br />
     work(ql,h1-,L,mid);work(h1,qr,mid+,R);<br />
 }<br />
 int main()<br />
 {<br />
     n=read();m=read();<br />
     for(int i=;i&lt;=n;i++)x[i]=read(),a[++cnt]=(node){,i,,,x[i]};<br />
     for(int i=;i&lt;=m;i++)<br />
     {<br />
         scanf("%s",ch+);<br />
         if(ch[]=='Q')<br />
         {<br />
             a[++cnt].op=;a[cnt].num=++qid;<br />
             a[cnt].l=read();a[cnt].r=read();a[cnt].k=read();<br />
         }<br />
         else<br />
         {<br />
             id=read();temp=read();<br />
             a[++cnt]=(node){,id,,-,x[id]};<br />
             a[++cnt]=(node){,id,,,x[id]=temp};<br />
         }<br />
     }<br />
     work(,cnt,-inf,inf);<br />
     for(int i=;i&lt;=qid;i++)printf("%d\n",ans[i]);<br />
     return ;<br />
 }</pre>
</div>
</div>
<p>带修改的主席树&hellip;&hellip;外面要套个树状数组。</p>
<div>
<div>
<pre class="prettyprint linenums"> #include&lt;cstdio&gt;<br />
 #include&lt;algorithm&gt;<br />
 #include&lt;cstring&gt;<br />
 #define LL long long<br />
 using namespace std;<br />
 const int N=2e4+;<br />
 int n,m,cnt,tot,id,tx,ty;<br />
 int A[N],B[N],C[N],a[N],tmp[N],rt[N],xx[N],yy[N];<br />
 int lc[N*],rc[N*],sum[N*];<br />
 char op[];<br />
 int read()<br />
 {<br />
     int x=,f=;char c=getchar();<br />
     while(c&lt;''||c&gt;''){if(c=='-')f=-;c=getchar();}<br />
     while(c&gt;=''&amp;&amp;c&lt;=''){x=x*+c-'';c=getchar();}<br />
     return x*f;<br />
 }<br />
 int lowbit(int x){return x&amp;(-x);}<br />
 void ins(int&amp; x,int last,int L,int R,int num,int c)<br />
 {<br />
     x=++tot;lc[x]=lc[last];rc[x]=rc[last];sum[x]=sum[last]+c;<br />
     if(L==R)return;int mid=(L+R)&gt;&gt;;<br />
     if(num&lt;=mid)ins(lc[x],lc[last],L,mid,num,c);<br />
     else ins(rc[x],rc[last],mid+,R,num,c);<br />
 }<br />
 void add(int x,int c)<br />
 {<br />
     id=lower_bound(tmp+,tmp+cnt+,a[x])-tmp;<br />
     for(int i=x;i&lt;=n;i+=lowbit(i))ins(rt[i],rt[i],,cnt,id,c);<br />
 }<br />
 int query(int L,int R,int num)<br />
 {<br />
     if(L==R)return L;<br />
     int ans=,mid=(L+R)&gt;&gt;;<br />
     for(int i=;i&lt;=tx;i++)ans-=sum[lc[xx[i]]];<br />
     for(int i=;i&lt;=ty;i++)ans+=sum[lc[yy[i]]];<br />
     if(num&lt;=ans)<br />
     {<br />
         for(int i=;i&lt;=tx;i++)xx[i]=lc[xx[i]];<br />
         for(int i=;i&lt;=ty;i++)yy[i]=lc[yy[i]];<br />
         return query(L,mid,num);<br />
     }<br />
     else<br />
     {<br />
         for(int i=;i&lt;=tx;i++)xx[i]=rc[xx[i]];<br />
         for(int i=;i&lt;=ty;i++)yy[i]=rc[yy[i]];<br />
         return query(mid+,R,num-ans);<br />
     }<br />
 }<br />
 int main()<br />
 {<br />
     n=read();m=read();cnt=n;<br />
     for(int i=;i&lt;=n;i++)tmp[i]=a[i]=read();<br />
     for(int i=;i&lt;=m;i++)<br />
     {<br />
         scanf("%s",op+);<br />
         A[i]=read();B[i]=read();<br />
         if(op[]=='Q')C[i]=read();<br />
         else tmp[++cnt]=B[i];<br />
     }<br />
     sort(tmp+,tmp+cnt+);<br />
     cnt=unique(tmp+,tmp+cnt+)-tmp-;<br />
     for(int i=;i&lt;=n;i++)add(i,);<br />
     for(int i=;i&lt;=m;i++)<br />
         if(C[i])<br />
         {<br />
             tx=ty=;<br />
             for(int j=A[i]-;j;j-=lowbit(j))xx[++tx]=rt[j];<br />
             for(int j=B[i];j;j-=lowbit(j))yy[++ty]=rt[j];<br />
             printf("%d\n",tmp[query(,cnt,C[i])]);<br />
         }<br />
         else add(A[i],-),a[A[i]]=B[i],add(A[i],);<br />
     return ;<br />
 }</pre>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m8zrkg3q.html">https&colon;&sol;&sol;blog&period;helong&period;info&sol;blog&sol;2015&sol;03&sol;13&sol;jump&lowbar;consistent&lowbar;hash&sol;</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k2d338.html">多层数据库应用基于Delphi DataSnap方法调用的实现（一）返回数据集</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q23r4x9.html">Smali语法编程</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqd3n308.html">【leetcode】Valid Sudoku  &lpar;easy&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxmd6z9.html">小韦XPSP3 V10&period;0&lowbar;Ghost精简版</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmnoxx9.html">通过HttpClient来调用Web Api接口</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xdg6v8.html">Arc Engine 中添加气泡提示框</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x2pyz9.html">ZABBIX安装官方指南</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j055deq.html">Java实现将指定目录内的指定类型的文件归类</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj156j8.html">cocos2d-x学习日志&lpar;10&rpar; --射击游戏&lpar;喵星战争&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jgp6w8.html">Java数据结构和算法总结-数组、二分查找</a>
		</li>
						<li><a href="https://www.batexi.com/a/950vlgv8.html">SpringMVC&lowbar;第一个程序</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj22238.html">java频繁new对象的优化方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jrx5l8.html">vscode在vue-cli中按照ESlint自动格式化代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ooldg8.html">Python基础理论 - 函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/q252yl3q.html">集合总结--ArrayList、LinkedList、HashMap</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd7jdv9.html">linux&amp;amp&semi;php：ubuntu安装php-7&period;2</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kw1gvq.html">ansible源码解读</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnnwdxkq.html">POJ1511来回最短路</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2zjzj8.html">nginx keepalived 高可用方案（转）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9pwm0048.html">利用LVS&plus;Keepalived搭建Mysql双主复制高可用负载均衡环境</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1rpm028.html">Django  模板 继承和包含</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5ydzmq.html">sublime中编辑服务器上的文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wdxewq.html">django基于restframework的CBV封装</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4jmzyeq.html">plink&colon; 等位型计数（allele count）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxdok2v9.html">mfc01</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxdolev9.html">关于Tcpdump抓包总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdwddk09.html">org&period;apache&period;catalina&period;LifecycleException&colon; Failed to start component &lbrack;StandardEngine&lbrack;Catalina&rsqb;&period;Standard</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gj44779.html">reportgen &colon;python生产pptx</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxdoeej9.html">《玩转Django2&period;0》读书笔记-探究视图</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
